/*
 * Copyright (c) 2014, NVIDIA CORPORATION.  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms and conditions of the GNU General Public License,
 * version 2, as published by the Free Software Foundation.
 *
 * This program is distributed in the hope it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 */

#ifndef _DT_BINDINGS_PADCTRL_TEGRA210_PADS_H
#define _DT_BINDINGS_PADCTRL_TEGRA210_PADS_H



/* IO PAD group */
#define TEGRA_IO_PAD_GROUP_AUDIO	0
#define TEGRA_IO_PAD_GROUP_AUDIO_HV	1
#define TEGRA_IO_PAD_GROUP_CAM		2
#define TEGRA_IO_PAD_GROUP_CSIA		3
#define TEGRA_IO_PAD_GROUP_CSIB		4
#define TEGRA_IO_PAD_GROUP_CSIC		5
#define TEGRA_IO_PAD_GROUP_CSID		6
#define TEGRA_IO_PAD_GROUP_CSIE		7
#define TEGRA_IO_PAD_GROUP_CSIF		8
#define TEGRA_IO_PAD_GROUP_DBG		9
#define TEGRA_IO_PAD_GROUP_DEBUG_NONAO	10
#define TEGRA_IO_PAD_GROUP_DMIC		11
#define TEGRA_IO_PAD_GROUP_DP		12
#define TEGRA_IO_PAD_GROUP_DSI		13
#define TEGRA_IO_PAD_GROUP_DSIB		14
#define TEGRA_IO_PAD_GROUP_DSIC		15
#define TEGRA_IO_PAD_GROUP_DSID		16
#define TEGRA_IO_PAD_GROUP_EMMC		17
#define TEGRA_IO_PAD_GROUP_EMMC2	18
#define TEGRA_IO_PAD_GROUP_GPIO		19
#define TEGRA_IO_PAD_GROUP_HDMI		20
#define TEGRA_IO_PAD_GROUP_HSIC		21
#define TEGRA_IO_PAD_GROUP_LVDS		22
#define TEGRA_IO_PAD_GROUP_MIPI_BIAS	23
#define TEGRA_IO_PAD_GROUP_PEX_BIAS	24
#define TEGRA_IO_PAD_GROUP_PEX_CLK1	25
#define TEGRA_IO_PAD_GROUP_PEX_CLK2	26
#define TEGRA_IO_PAD_GROUP_PEX_CTRL	27
#define TEGRA_IO_PAD_GROUP_SDMMC1	28
#define TEGRA_IO_PAD_GROUP_SDMMC3	29
#define TEGRA_IO_PAD_GROUP_SPI		30
#define TEGRA_IO_PAD_GROUP_SPI_HV	31
#define TEGRA_IO_PAD_GROUP_UART		32
#define TEGRA_IO_PAD_GROUP_USB_BIAS	33
#define TEGRA_IO_PAD_GROUP_USB0		34
#define TEGRA_IO_PAD_GROUP_USB1		35
#define TEGRA_IO_PAD_GROUP_USB2		36
#define TEGRA_IO_PAD_GROUP_USB3		37
#define TEGRA_IO_PAD_GROUP_BB		38
#define TEGRA_IO_PAD_GROUP_SYS		39
#define TEGRA_IO_PAD_GROUP_HV		40

#define TEGRA210_PAD_SYS		TEGRA_IO_PAD_GROUP_SYS
#define TEGRA210_PAD_UART		TEGRA_IO_PAD_GROUP_UART
#define TEGRA210_PAD_BB			TEGRA_IO_PAD_GROUP_BB
#define TEGRA210_PAD_AUDIO		TEGRA_IO_PAD_GROUP_AUDIO
#define TEGRA210_PAD_CAM		TEGRA_IO_PAD_GROUP_CAM
#define TEGRA210_PAD_PEX_CTRL		TEGRA_IO_PAD_GROUP_PEX_CTRL
#define TEGRA210_PAD_SDMMC1		TEGRA_IO_PAD_GROUP_SDMMC1
#define TEGRA210_PAD_SDMMC3		TEGRA_IO_PAD_GROUP_SDMMC3
#define TEGRA210_PAD_HV			TEGRA_IO_PAD_GROUP_HV
#define TEGRA210_PAD_AUDIO_HV		TEGRA_IO_PAD_GROUP_AUDIO_HV
#define TEGRA210_PAD_DBG		TEGRA_IO_PAD_GROUP_DBG
#define TEGRA210_PAD_DMIC		TEGRA_IO_PAD_GROUP_DMIC
#define TEGRA210_PAD_GPIO		TEGRA_IO_PAD_GROUP_GPIO
#define TEGRA210_PAD_SPI		TEGRA_IO_PAD_GROUP_SPI
#define TEGRA210_PAD_SPI_HV		TEGRA_IO_PAD_GROUP_SPI_HV

#define IO_PAD_VOLTAGE_1_8V	1800000
#define IO_PAD_VOLTAGE_3_3V	3300000

#define TEGRA_IO_PAD_GROUP_POWER_DISABLE	0
#define TEGRA_IO_PAD_GROUP_POWER_ENABLE		1

#endif
